osl::rating::ImmediateAddSupport Class Reference

`#include <feature.h>`

Inheritance diagram for osl::rating::ImmediateAddSupport:

## Classes

struct | Test

## Public Member Functions

| ImmediateAddSupport (Ptype self, Ptype attack)
bool | match (const NumEffectState &state, Move move, const RatingEnv &env) const
bool | effectiveInCheck () const
Public Member Functions inherited from osl::rating::Feature
| Feature (const std::string &name)
virtual | ~Feature ()
const std::string & | name () const

## Static Public Member Functions

static int | index (const NumEffectState &state, Move move, const RatingEnv &env)

## Private Attributes

Ptype | self
Ptype | attack

## Detailed Description

Definition at line 183 of file rating/feature.h.

## Constructor & Destructor Documentation

## ImmediateAddSupport()

osl::rating::ImmediateAddSupport::ImmediateAddSupport | ( | Ptype | self,
|  | Ptype | attack )

Definition at line 62 of file feature.cc.

References attack, osl::rating::Feature::Feature(), osl::Ptype_Table, and self.

## Member Function Documentation

## effectiveInCheck()

bool osl::rating::ImmediateAddSupport::effectiveInCheck | ( |  | ) | const

inline virtual

Reimplemented from osl::rating::Feature.

Definition at line 190 of file rating/feature.h.

## index()

int osl::rating::ImmediateAddSupport::index | ( | const NumEffectState & | state,
|  | Move | move,
|  | const RatingEnv & | env )

static

Definition at line 88 of file feature.cc.

References osl::alt(), osl::misc::GeneralMask< Integer >::any(), osl::NumEffectState::effectedMask(), osl::NumEffectState::forEachEffectOfPiece(), osl::PieceMask::getMask(), osl::NumEffectState::hasEffectByPiece(), osl::NumEffectState::hasEffectIf(), osl::rating::RatingEnv::history, osl::Move::isNormal(), osl::container::MoveStack::lastMove(), osl::SimpleState::pieceOf(), osl::SimpleState::pieceOnBoard(), osl::NumEffectState::piecesOnBoard(), osl::Move::ptype(), osl::Piece::ptype(), osl::PTYPE_MAX, osl::PTYPE_PIECE_MIN, osl::Ptype_Table, osl::Move::ptypeO(), osl::Piece::square(), osl::misc::GeneralMask< Integer >::takeOneBit(), osl::Move::to(), and osl::SimpleState::turn().

Referenced by osl::rating::ImmediateAddSupportGroup::findMatch().

## match()

bool osl::rating::ImmediateAddSupport::match | ( | const NumEffectState & | state,
|  | Move | move,
|  | const RatingEnv & | env ) const

virtual

Implements osl::rating::Feature.

Definition at line 69 of file feature.cc.

References attack, osl::NumEffectState::forEachEffectOfPiece(), osl::rating::RatingEnv::history, osl::Move::isNormal(), osl::container::MoveStack::lastMove(), osl::SimpleState::pieceOnBoard(), osl::Move::ptype(), self, and osl::Move::to().

## Member Data Documentation

## attack

Ptype osl::rating::ImmediateAddSupport::attack

private

Definition at line 186 of file rating/feature.h.

Referenced by ImmediateAddSupport(), and match().

## self

Ptype osl::rating::ImmediateAddSupport::self

private

Definition at line 186 of file rating/feature.h.

Referenced by ImmediateAddSupport(), and match().

The documentation for this class was generated from the following files:

- rating/feature.h
- feature.cc